/******* FORMULAE MODALIZER ******/

fml AltBox(prg P,fml A)
{
  prg Pback,Pforth;

  Pback=Inverse(CopyPrg(P));
  Pforth=CopyPrg(P);

  return Box(P,Box(Pback,Box(Pforth,A)));

}

fml AltPos(prg P, fml A)
{

  prg Pback,Pforth;

  Pback=Inverse(CopyPrg(P));
  Pforth=CopyPrg(P);

  return Pos(P,Pos(Pback,Pos(Pforth,A)));

}

fml GenerateModalVariable(ident var)
{
  integer i,j;

  fml A[3],Qi,NQi;

  if (flag_Kenc) {
    Qi=AltPos(Rel(ONE),Var(ONE));
    for (j=1; j<var; j++)
      Qi=AltPos(Rel(ONE),Qi);
    A[2]=AltPos(Rel(ONE),And(WithFml(Not(Var(ONE)),WithFml(Qi,EMPTY_SEQUENT))));
  }
  else {
    for (i=0;i<2;i++) {
      Qi=AltPos(Rel(ONE),AltBox(Rel(ONE),Var(ONE)));
      for (j=1; j<var;j++)
	Qi=AltPos(Rel(ONE),And(WithFml(Var(ONE),
			    WithFml(AltPos(Rel(ONE),And(WithFml(Not(Var(ONE)),
					     WithFml(Qi,EMPTY_SEQUENT)))),
			    EMPTY_SEQUENT))));
      NQi=AltBox(Rel(ONE),AltPos(Rel(ONE),Not(Var(ONE))));
      for (j=1; j<=var;j++)
	NQi=AltBox(Rel(ONE),Or(WithFml(Not(Var(ONE)),
		       WithFml(AltBox(Rel(ONE),Or(WithFml(Var(ONE),
				       WithFml(NQi,EMPTY_SEQUENT)))),
		       EMPTY_SEQUENT))));
      A[i]=AltPos(Rel(ONE),And(WithFml(Qi,WithFml(NQi,EMPTY_SEQUENT))));
    }
    A[2]=And(WithFml(AltPos(Rel(ONE),A[0]),
	     WithFml(AltBox(Rel(ONE),Or(WithFml(Not(A[1]),
			     WithFml(AltPos(Rel(ONE),AltBox(Rel(ONE),Not(Var(ONE)))),
			     EMPTY_SEQUENT)))),
	     EMPTY_SEQUENT)));
  }
  return A[2];
}


prg ModalizePrg(prg);

fml ModalizeFml(fml A)
{
  sequent Asub;
  fml MA;

  if (A==NOT_EXISTS_FML) {
    printf("\nERROR - Formula do not exists - ERROR\n");
    exit(1);
  }

  switch (A->op) {
  case UNKNOWN:
  case FALSE: 
  case TRUE:
    break;
  case VAR:
    MA=GenerateModalVariable(A->name);
    DeleteFml(A);
    A=MA;
    break;
  case NOT:
  case AND:
  case OR:
  case XOR:
  case EQUIV:
  case IMP:
    for (Asub=A->subfml; Asub!=EMPTY_SEQUENT; Asub = Asub->rest)
      Asub->first=ModalizeFml(Asub->first);
    break;
  case BOX:
  case POS:
    A->subprg->first=ModalizePrg(A->subprg->first);
    for (Asub=A->subfml; Asub!=EMPTY_SEQUENT; Asub = Asub->rest)
      Asub->first=ModalizeFml(Asub->first);
    break;
  }
  return A;
}

prg ModalizePrg(prg P)
{
  pool Psub;

  if (P==NOT_EXISTS_PRG) {
    fprintf(stderr,"\nERROR - Program does not exists - ERROR\n");
    exit(1);
  }

  switch (P->op) {
  case UNKNOWN:
  case REL:
    break;
  case INVERSE:
  case UNION:
  case SEQUENCE:
  case STAR:
    for (Psub=P->subprg; Psub!=EMPTY_POOL; Psub = Psub->rest)
      Psub->first=ModalizePrg(Psub->first);
    break;
  case TEST:
    P->subfml->first=ModalizeFml(P->subfml->first);
    break;

  }
  return P;
}

sequent ModalizeFormulae(sequent S)
{
  sequent NS;
  
  for (NS=S;NS!=EMPTY_SEQUENT;NS=NS->rest)
    NS->first=ModalizeFml(NS->first);

  return S;
}
