/******* MAIN FILE  ******/

integer FindWorkableDepth(integer depth, integer vars)
{
  integer power,big_power;

  big_power=0;
  power=1;
  while (big_power<power) {
    big_power=power;
    power*=2;
  }
  
  if (depth==-1)
    return (Random1To(big_power/vars));
  else if (depth>big_power/vars) {
    fprintf(stderr,"ERROR - Alternation depth too big - ERROR\n");
    fprintf(stderr,"Approv Max for these var numbers = %ld\n",big_power/vars);
    exit(1);
  }
  else
    return depth;
}

int main(int argc, char *argv[])
{
  sequent QBFS,ModS,AltS,Sgoal;
  integer instance;
  int i;
  FILE *fp;

  ScanParameters(argc,argv);

  InitRandom();

  Sgoal=WithFml(False(),EMPTY_SEQUENT);

  MaxDepth=FindWorkableDepth(MaxDepth,MaxVariables);
    
  QBFS=EMPTY_SEQUENT;
  ModS=EMPTY_SEQUENT;
  AltS=EMPTY_SEQUENT;
  for(instance=1; instance<=NthInstance; instance++) {
    DeleteSequent(QBFS);
    DeleteSequent(ModS);
    DeleteSequent(AltS);

    QBFS=GenerateQuantifiedFormulae();
    ModS=GenerateModalFormulae(QBFS);
    AltS=GenerateAltFormulae(QBFS);

    if (flag_Kenc || flag_S4enc) {
      ModS=ModalizeFormulae(ModS);
      AltS=ModalizeFormulae(AltS);
    }
    if (flag_all || instance==NthInstance) {
      if (flag_stdio) {
	PrintBanner();
	PrintSequent(ModS,"mod","hypothesis");
	PrintSequent(AltS,"alt","hypothesis");
	PrintSequent(Sgoal,"result","conjecture");
      }
      else {
	fp=OpenFile(instance);
	FprintBanner(fp);
	FprintSequent(fp,ModS,"mod","hypothesis");
	FprintSequent(fp,AltS,"alt","hypothesis");
	FprintSequent(fp,Sgoal,"result","conjecture");
	fclose(fp);
      }
    }
  }
  DeleteSequent(QBFS);
  DeleteSequent(AltS);
  DeleteSequent(ModS);
  DeleteSequent(Sgoal);

  return 0;
}



